/************************************************************************
*                               Reader ()                               *
* ===================================================================== *
*                                                                       *
* Function:  Waits for read access to the shared memory segment.        * 
*                                                                       * 
*                                                                       * 
*                                                                       * 
*                                                                       * 
*                                                                       * 
************************************************************************/

#include "header.h"


void *reader(void *parm)
{

	int num_p = (int ) (long )parm;
        int     i, num_r, num_w;
        char    *ptr;
	char    read_from_mem;
        unsigned long cksum_r = 0;
        unsigned long *ulptr_r;
	
        num_r = num_p % num_readers;
        num_w = num_p - num_r;
        num_w = num_w / num_readers;
	ptr = shmptr[num_w];
        ulptr_r = checksum[num_w];
	
        if(pthread_mutex_lock (&cond_mutex[num_w]))
                perror("Can't Take Cond Lock : ");

        while(thread_hold[num_w])
        {
                if(pthread_cond_wait(&cond_var[num_w], &cond_mutex[num_w]))
                        perror("cond_wait failed : ");
        }

        if(pthread_mutex_unlock(&cond_mutex[num_w]))
                perror("Release cond Lock Failed : ");

        if(pthread_mutex_lock(&mutex_r[num_w]))
                perror("Can't take read Lock : ");

        (*(read_count [num_w]))++;

        if(pthread_mutex_unlock(&mutex_r[num_w]))
                perror("Can't Release Read Lock : ");

        for(i = 0; i < buffer_size; i++)
                cksum_r = *ptr++;

        if(pthread_mutex_lock(&mutex_r[num_w]))
                perror("Can't Take Read Lock : ");
	
        (*(read_count [num_w]))++;

        if(pthread_mutex_unlock(&mutex_r[num_w]))
                perror("Can't Release 1 Read Lock : ");

        *ulptr_r = cksum_r;

        printf("\tReader (%02d) of Writer (%02d): checksum %04ld\n",\
                                                num_r, num_w, cksum_r);
	
        return NULL;

}
