/************************************************************************
*                               writer ()                               *
* ===================================================================== *
*                                                                       *
* Function:  Fill the "scratch" shared memory segment up with data.     *
*            Release "write" lock so that the reader are able to start. *
*                                                                       *
*                                                                       *
*                                                                       *
************************************************************************/

#include "header.h"

void *writer(void *parm)
{

        int num_w = (int ) (long )parm;
        unsigned long cksum_w = 0; 
        char  data = 0;
	int   i;
        char *ptr;
	char *write_to_mem;

        data = num_w;
	shmptr[num_w] = shmaddr;
	
        for(ptr = shmptr[num_w]; ptr < (shmptr[num_w] + buffer_size); ptr++) {
                *ptr = data++;
                cksum_w += *ptr;
        }

        if(pthread_mutex_lock(&cond_mutex[num_w]))
                perror("Mutex_lock Failed");

        thread_hold[num_w] = 0;

        if(pthread_cond_broadcast(&cond_var[num_w]))
                perror("cond_signal Failed");

        if(pthread_mutex_unlock(&cond_mutex[num_w]))
                perror("Mutex_unlock Failed");

        cksum[num_w] = cksum_w;
        printf("\n\tWriter (%02d): shared memory checksum %04ld\n", \
                                                         num_w, cksum_w);

        return NULL;

}
